package scacchi.prova;

import java.io.IOException;

import scacchi.prova.InterfacciaComandiScacchi;

/**
 * Verifica il funzionamento della versione di prova di 
 * {@link scacchi.prova.PartitaScacchi PartitaScacchi}.
 */
public class Prova {

    /** La classe non &egrave; istanziabile */
    private Prova() {};

    /**
     * Inizializza una interafaccia per i comandi del gioco degli scacchi ed
     * esegue un ciclo di lettura di un comando, esecuzione e stampa del
     * risultato.
     */
    public static void main(String args[]) {
	InterfacciaComandiScacchi interfaccia =
	    new InterfacciaComandiScacchi();

	while (true) {
	    try {
		interfaccia.nextComando();
		if (interfaccia.errore()) {
		    if (interfaccia.cmd().equals("quit")) {
			System.out.println("\nArrivederci!");
			return;
		    }
		    System.out.println(interfaccia.msg());
		} else
		    System.out.println(interfaccia.out());		
	    } catch  (IOException e) {
		System.out.println(e.getMessage());
	    }
	}
    }
}
