package scacchi.soluzione;

import scacchi.main.Partita;
import scacchi.main.ArgomentiComando.*;
import scacchi.main.EccezioniTesto.*;
import scacchi.main.EccezioniPartita.*;

// ------------------------------------------------------------ 
// Versione dummy.
//
// Non fa nulla. Serve solo per compilare correttamente
// le classi del package scacchi.main che dipendono 
// ------------------------------------------------------------

/**
 * Implementazione della interfaccia 
 * {@link scacchi.main.Partita} che implementa le regole del gioco degli
 * scacchi.
 */
public class PartitaScacchi implements Partita {
    /**
     * Crea una nuova partita che comincia dalla posizione iniziale del gioco.
     */
    public PartitaScacchi() {};

    /**
     * Crea una nuova partita che comincia da una posizione data.
     * @param n Il numero di mossa da cui comincia la partita. Se positivo
     *          il tratto &egrave; al BIANCO, se negativo al NERO.
     * @param l La lista delle posizioni dei pezzi che descrive la 
     *          posizione di inizio della partita.
     * @throws scacchi.main.EccezioniPartita.PosizioneInizialeException 
     *         Se la posizione di partenza non verifica le seguenti
     *         condizioni:
     *         <ol>
     *         <li>nella posizione ci sono un (solo) Re BIANCO ed un
     *             (solo) Re NERO</li>
     *         <li>il Re del giocatore che non ha il tratto non &egrave;
     *             sotto scacco</li>
     *         <li>la pozione non contiene pedoni (di alcun colore) nella
     *             prima ed ottava traversa</li>
     *         </ol>
     */
    public PartitaScacchi(int n, ListaPosPezziTesto l)
	throws PosizioneInizialeException {}

    public int getNumMossa() { return 1; }

    public ListaPosPezziTesto eseguiMossa(MossaTesto m)
	throws MossaException {	return null; };

    public ListaPosPezziTesto tornaIndietro()
	throws NoMoreMosseException { return null; };

    public ListaPosPezziTesto tornaIndietro(int n)
	throws NoMoreMosseException { return null; }

    public ListaMosseTesto listaMosse() { return null; }

    public ListaMosseTesto listaMosse(int n)
	throws NoMoreMosseException { return null; }

    public ListaPosPezziTesto getPosizionePezzi() { return null; }

    public ListaCaseTesto caseControllate(CasaTesto c)
	throws CasaVuotaException { return null; }

    public ListaCaseTesto caseControllate(boolean colore) { return null; }

    public ListaCaseTesto caseControllate() { return null; }

    public ListaPosPezziTesto casaControllataDa(CasaTesto c, boolean colore) {
	return null; }

    public ListaCaseTesto getMossePossibili(CasaTesto c) { return null; }

    public ListaMosseTesto getMossePossibili() { return null; }

    public ListaMosseTesto getMosseValide(CasaTesto c) { return null; }

    public ListaMosseTesto getMosseValide() { return null; }

    public boolean scaccoAlRe() { return false; };
}
