package scacchi.soluzione;

import scacchi.main.Partita;
import scacchi.main.ArgomentiComando.*;
import scacchi.main.EccezioniTesto.*;
import scacchi.main.EccezioniPartita.*;

/**
 * Implementazione della interfaccia 
 * {@link scacchi.main.Partita} che implementa le regole del gioco degli
 * scacchi.
 */
public class PartitaScacchi implements Partita {
	/**
	* Crea una nuova partita che comincia dalla posizione iniziale del gioco.
	*/

	info log;
	
	public PartitaScacchi() {
			log = new info();
	}

	/**
	* Crea una nuova partita che comincia da una posizione data.
	* @param n Il numero di mossa da cui comincia la partita. Se positivo
	*          il tratto &egrave; al BIANCO, se negativo al NERO.
	* @param l La lista delle posizioni dei pezzi che descrive la 
	*          posizione di inizio della partita.
	* @throws scacchi.main.EccezioniPartita.PosizioneInizialeException 
	*         Se la posizione di partenza non verifica le seguenti
	*         condizioni:
	*         <ol>
	*         <li>nella posizione ci sono un (solo) Re BIANCO ed un
	*             (solo) Re NERO</li>
	*         <li>il Re del giocatore che non ha il tratto non &egrave;
	*             sotto scacco</li>
	*         <li>la pozione non contiene pedoni (di alcun colore) nella
	*             prima ed ottava traversa</li>
	*         </ol>
	*/
	public PartitaScacchi(int n, ListaPosPezziTesto l)
		throws PosizioneInizialeException {}

	public int getNumMossa() { 
		return log.mossa;
	} 

	public ListaPosPezziTesto eseguiMossa(MossaTesto m)
		throws MossaException {
			log.update(m);
			return log.LPPT;
	};

    public ListaPosPezziTesto tornaIndietro() 
	throws NoMoreMosseException { 
		log.torna();
		return log.LPPT;
	}

    public ListaPosPezziTesto tornaIndietro(int n)
	throws NoMoreMosseException { 
		for(int c = 0; c < n; c++) // c/c++ is better than java
			log.torna();
		return log.LPPT;
	}

    public ListaMosseTesto listaMosse() { 
		return log.LMT;
    }

    public ListaMosseTesto listaMosse(int n)
	throws NoMoreMosseException { return null; }

	public ListaPosPezziTesto getPosizionePezzi() { 
		return log.LPPT;
	}

	int casaVuota(int[] coord) {
		String lppttemp = log.LPPT.toString();
		int index = lppttemp.indexOf(scoordinate(coord));
		if(index != -1)
			return index+1;
		else
			return 0;
	}

	public ListaCaseTesto caseControllate(CasaTesto c)
	throws CasaVuotaException { 
		ListaCaseTesto LCT = null;
		String lppttemp = log.LPPT.toString();
		int[] coord = coordinate(c);
		int[] coord2 = new int[2];
		String controllate = new String("");
		int index = casaVuota(coord);
		if(index == 0) 
			throw new CasaVuotaException(c);
		int colore = 1; // bianco
		char y = lppttemp.charAt(index - 2);
		Character x = new Character(y);
		if(x.isLowerCase(x.charValue()))
			colore = 2; // nero
		y = x.toLowerCase(x.charValue());
		switch(y) {
			case  'p':
				if(colore == 1) {
					if(coord[0] > 1) {
						coord2[0] = coord[0] - 1;
						coord2[1] = coord[1] + 1;
						controllate += scoordinate(coord2);
					}

					if(coord[0] < 8) {
						coord2[0] = coord[0] + 1;
						coord2[1] = coord[1] + 1;
						controllate += scoordinate(coord2);
					}
				}
	
				if(colore == 2) {
					if(coord[0] > 1) {
						coord2[0] = coord[0] - 1;
						coord2[1] = coord[1] - 1;
						controllate += scoordinate(coord2);
					}

					if(coord[0] < 8) {
						coord2[0] = coord[0] + 1;
						coord2[1] = coord[1] - 1;
						controllate += scoordinate(coord2);
					}
				}
			break;
			
			case 'c':
				if(coord[0] > 1 && coord[1] < 7) {
					coord2[0] = coord[0] - 1; 
					coord2[1] = coord[1] + 2;
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8 && coord[1] < 7) {				
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] + 2;
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 7 && coord[1] < 8) {
					coord2[0] = coord[0] + 2;
					coord2[1] = coord[1] + 1;
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 7 && coord[1] > 1) {
					coord2[0] = coord[0] + 2;
					coord2[1] = coord[1] - 1;
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 7 && coord[1] > 2) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] - 2;
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 1 && coord[1] > 2) {
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1] - 2;
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 2 && coord[1] > 1) { 
					coord2[0] = coord[0] - 2;
					coord2[1] = coord[1] - 1;
					controllate += scoordinate(coord2);
				}				
				if(coord[0] > 2 && coord[1] <= 7) {
				// perche' siamo acheeeeer 
					coord2[0] = coord[0] - 2;
					coord2[1] = coord[1] + 1;
					controllate += scoordinate(coord2);
				}
			break;
			// miiii che fatica
		
			case 'r':
				if(coord[1] < 8) {
					coord2[0] = coord[0]; 
					coord2[1] = coord[1] + 1;
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8 && coord[1] < 8) {			
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] + 1;
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1];
					controllate += scoordinate(coord2);
				}
				if(coord[0] < 8 && coord[1] > 1) {
					coord2[0] = coord[0] + 1;
					coord2[1] = coord[1] - 1;
					controllate += scoordinate(coord2);
				}
				if(coord[1] > 1) {
					coord2[0] = coord[0];
					coord2[1] = coord[1] - 1;
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 1 && coord[1] > 1) {
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1] - 1;
					controllate += scoordinate(coord2);
				}
				if(coord[0] > 1) { 
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1];
					controllate += scoordinate(coord2);
				}				
				if(coord[0] > 1 && coord[1] <= 7) {
				// perche' siamo acheeeeer 
					coord2[0] = coord[0] - 1;
					coord2[1] = coord[1] + 1;
					controllate += scoordinate(coord2);
				}
			break;
			// copia&incolla rules

			case 't':
				controllate = Rat(coord, 1);
			break;

			case 'a':
				controllate = Rat(coord, -1);
			break;

			case 'd':
				controllate = Rat(coord, 0);
			break;
		}
	


		try { 
			LCT = new ListaCaseTesto(controllate);
		} catch(NotazioneException ne) {
			System.out.println("notazione exception case controllate");
		}
    	
	return LCT;
	}

	private	int[] coordinate(CasaTesto c) {
		int riga, colonna;
		char x;
		x = c.toString().charAt(0);
		colonna = (int)(x - 'a') + 1;
		x = c.toString().charAt(1);
		riga = (int)(x - '1') + 1;
		int[] coordinate = { colonna, riga };
		return coordinate;
	}
	
	private String scoordinate(int[] coordinate) {
		String S = new String("");
		Character C = new Character((char)(coordinate[0] - 1 + 'a'));
		S += C.toString();
		C = new Character((char)(coordinate[1] - 1 + '1'));
		S += C.toString() + " ";
		return S;
	}

	private String Rat(int[] coord, int pezzo) {
		int[] coord2 = {coord[0], coord[1]};
		String ret = new String("");
		if(pezzo > -1) {
			for(int i = coord[0] + 1; i < 9; i++) {
				coord2[0] = i;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0)
					break;
			}

			for(int i = coord[0] - 1; i > 0; i--) {
				coord2[0] = i;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0)
					break;
			}

			for(int i = coord[1] + 1; i < 9; i++) {
				coord2[1] = i;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0)
					break;
			}

			for(int i = coord[1] - 1; i > 0; i--) {
				coord2[1] = i;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0)
					break;
			}
		}	
			
		if(pezzo < 1) {
			int j=1;
			for(int i = coord[0] + 1; i < 9; i++) {
				coord2[0] = i;
				coord2[1] = coord[1] + j;
				j++;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0 || coord2[1] > 8)
					break;
			}
			
			j = 1;
			for(int i = coord[0] - 1; i > 0; i--) {
				coord2[0] = i;
				coord2[1] = coord[1] - j ;
				j++;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0 || coord2[1] < 1) 
					break;
			}
			
			j = 1;
			for(int i = coord[0] + 1; i < 9; i++) {
				coord2[0] = i;
				coord2[1] = coord[1] - j;
				j++;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0 || coord2[1] < 1)
					break;
			}
			j = 1;
			for(int i = coord[0] - 1; i > 0; i--) {
				coord2[0] = i;
				coord2[1] = coord[1] + j;
				j++;
				ret += scoordinate(coord2);
				if(casaVuota(coord2) == 0 || coord2[1] > 8)
					break;
			}
		}
	System.out.println(ret);
	return ret;

	// XXX: dobbiamo controllare bene queste funzioni del cazzo
	// OK!? buon lavoro pezzo di merda.
	// acheeeeeeeeeeeRRRRRRRRRrrrrrrrrrrrrrrrrrr.......

	}						
							
    public ListaCaseTesto caseControllate(boolean colore) { return null; }

    public ListaCaseTesto caseControllate() { return null; }

    public ListaPosPezziTesto casaControllataDa(CasaTesto c, boolean colore) {
	return null; }

    public ListaCaseTesto getMossePossibili(CasaTesto c) { return null; }

    public ListaMosseTesto getMossePossibili() { return null; }

    public ListaMosseTesto getMosseValide(CasaTesto c) { return null; }

    public ListaMosseTesto getMosseValide() { return null; }

    public boolean scaccoAlRe() { return false; };
}


class info { 

	ListaMosseTesto LMT;
	ListaCaseTesto LCT;
	ListaPosPezziTesto LPPT;
	ListaPosPezziTesto[] LPPTarray = new ListaPosPezziTesto[300];
	int mossa, count = 0;
	int[][] colorMatrice = new int[9][9];

	info() {
		try { 
			LMT = new ListaMosseTesto("");
			LCT = new ListaCaseTesto("");
			mossa = 1;
			LPPT = new ListaPosPezziTesto("Ta1 Cb1 Ac1 Dd1 Re1 Af1 Cg1 Th1 Pa2 Pb2 Pc2 Pd2 Pe2 " + 
						      "Pf2 Pg2 Ph2 ta8 cb8 ac8 dd8 re8 af8 cg8 th8 pa7 pb7 " +
						      "pc7 pd7 pe7 pf7 pg7 ph7");
		} catch(NotazioneException ne) {
			System.out.println("info exception");
		} 
	}

	void update(MossaTesto MT) {
		String lppttemp, lmttemp;
		int index;

		lmttemp = LMT.toString();
		lmttemp = lmttemp + " " + (MT.toString());
		
		lppttemp = LPPT.toString();
		try {
			LPPTarray[count] =  new ListaPosPezziTesto(lppttemp);
		} catch(NotazioneException ne) {
			System.out.println("info update exeption");
		}	

		index = lppttemp.indexOf(MT.toString().substring(2,4));
		if(index != -1) 
			lppttemp = lppttemp.replaceAll(lppttemp.substring(index-1, index+2), "");
						
		lppttemp = lppttemp.replaceAll(MT.toString().substring(0,2), MT.toString().substring(2,4));
		
		try {
			LMT = new ListaMosseTesto(lmttemp);
			LPPT = new ListaPosPezziTesto(lppttemp);
		} catch(NotazioneException ne) {
			System.out.println("info update exeption");
		}

		mossa = mossa > 0 ? (-mossa) : (-mossa) + 1;
		count++;		

	}

	void torna() throws NoMoreMosseException {
		if(count == 0)
			throw new NoMoreMosseException();
		else {
			count--;
			LPPT = LPPTarray[count];
		}

		String lmttemp, lmttemp2;
		lmttemp = LMT.toString();
		try {
			LMT = new ListaMosseTesto(lmttemp.substring(0, (lmttemp.length())-4));
		} catch (NotazioneException ne) {
			System.out.println("info torna exception");
		}
		mossa = mossa > 0 ? (-mossa) + 1 : -mossa; 
	}

}

